//============================================================================
// Name        : ShapeFactory.cpp
// Author      : Vikturek
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <fstream>
#include <map>
#include <vector>

using namespace std;

#define DRAWING_FILE "Drawing.txt"

class Shape {

public:
	virtual void draw() = 0;
	virtual void load(ifstream &file) = 0;
	virtual ~Shape(){}
};

class ShapeCircle: public Shape {

public:
	ShapeCircle(){}
	ShapeCircle(double _x, double _y, double _r){}
	virtual void draw(){
 	}
	virtual void load(ifstream &file){
	}
	virtual ~ShapeCircle(){}
};


class ShapeSquare: public Shape {

public:
	ShapeSquare(){}
	ShapeSquare(double _x, double _y, double _a){}
	virtual void draw(){
	}
	virtual void load(ifstream &file){
	}
	virtual ~ShapeSquare(){}
};


class Drawing {
public:
	typedef vector<Shape *> Shapes;
private:
	Shapes shapes;
public:
	void addShape(Shape *shape){
		shapes.push_back(shape);
	}
	void draw(){
		for(Shapes::iterator i = shapes.begin(); i != shapes.end(); ++i){
			(*i)->draw();
		}
	}
	void load(const char *fileName){
	}
};

int main() {
	Drawing drawing;

	drawing.addShape(new ShapeCircle(1, 1, 2));
	drawing.addShape(new ShapeSquare(2, 2, 4));
	drawing.draw(); // prints:	Circle: 1 1 2
			//		Square: 2 2 4
	drawing.load(DRAWING_FILE);
	drawing.draw();	// prints:	Circle: 1 1 2
			// 		Square: 2 2 4
			//		Circle: 1 1 3
			//		Square: 3 3 4

	return 0;
}

